import argparse, os, logging
logging.basicConfig(level=logging.DEBUG, format='%(asctime)s - %(levelname)s - %(message)s')
import numpy as np
from Video.preprocessing import Video
from Video.create import GENERATOR
from MP.poses import POSE
from GAN_Model.create_model import CROP_GAN
from build_opt import get_opt
from lang_sam.lang_utils import SAM_CROPS


if __name__ == '__main__':    
    # try:        
    ap = argparse.ArgumentParser("inference_multi")
    ap.add_argument("--CPU_NUM", default= 0,type=int)
    ap.add_argument("--n_jobs", default= 1,type=int)
    ap.add_argument("--main_path", default= "/home/basheer/Signapse/new/signapse/signapse",type=str)
    ap.add_argument("--input_path", default= '/home/basheer/Signapse/new/synthetic-signer/tmp', type=str)
    ap.add_argument("--start", default= 0, type=int)
    ap.add_argument("--stop", default= -1, type=int)
    ap.add_argument("--num_workers", default= 1, type=int)
    ap.add_argument("--GPU", default= 'cuda', type=str)
    ap.add_argument("--signer", default= 'Marcel', type=str)  
    ap.add_argument("--GAN_folder", default= 'Marcel_N2N_skin', type=str)      
    ap.add_argument("--detailed_video", default= False, type=bool)
    ap.add_argument("--organisation_id", default= 0, type=int)
    ap.add_argument("--sign_result_queue_url", default= 0, type=int)
    ap.add_argument("--synthetic_sign_results_bucket", default= 0, type=int)
    args = ap.parse_args()
    args = get_opt(args)   
    os.chdir(args.main_path)     

    for root, dirs, files in os.walk(args.input_path):
        n_files = len(files)
        start_index = int((args.CPU_NUM * np.ceil(n_files / args.n_jobs)))
        end_index = int(((args.CPU_NUM+1) * np.ceil(n_files / args.n_jobs)))
        files = files[start_index:end_index]
        logging.info(f"len(files) = {len(files)}")

        for file in sorted(files):
            if file.lower().endswith((".mp4", ".avi", ".mov")):
                args.input_video_path = os.path.join(root, file)   
                args.sign_request_id = os.path.splitext(os.path.basename(args.input_video_path))[0]     
                if not os.path.exists(f"{args.main_path}/outputs/{args.sign_request_id}.mp4"):
                    sign_request_id = args.sign_request_id
                    video_file_name = sign_request_id + ".mp4"
                    args.video_file_name = video_file_name 

                    GAN_model = CROP_GAN(args).get_CROP_GAN_model()
                    img_centre, min_size , FPS, IMG_SHAPE = Video(args).process_video()
                    pose_tensor, Non_interpolated_MP_results,scale  = POSE(args).get_all_frames(img_centre, min_size)
                    pose_tensor  = POSE(args).postprocessing(pose_tensor)
                    SAM_CROPS(args).sam_masks(img_centre, len(pose_tensor))
                    GENERATOR(args).create_pose_video_from_MP(img_centre,min_size,FPS,pose_tensor,GAN_model)
                    print('\033[33m--------------Process completed ------------------\033[0m')
        
        
    # except Exception as e:
    #     #custom_signal_handler()
    #     print(f"Exception: {e}")